5 июля 2012 г.

HP E-PC 40

Достался мне на днях на весьма выгодных условиях такой вот монстр, древний как каптях мамонта: Hewlett Packard HP E-PC 40.
Характеристики этого зверя:
- CPU 1,2 ГГц Celeron
- RAM 256 МБ + 128 МБ PC133 (max RAM capacity - 512 МБ)
- HDD 20 ГБ
- видео, примерно, 16 МБ, сеть, звук АС97 - все на борту
- slim CD-ROM
- 4хUSB
- LPT
- COM

Вот так оно выглядит.

Что ставить и зачем он мне - я еще не выяснил. Вот осваиваю Ubuntu Server в виртуалбоксе - может и получится из этого агрегата торрентокачалка с web-мордой и ftp...

Установка ОСи прошла без каких либо сложностей - Ubuntu Server 10.04 встала шустро и работоспособно - устанавливается она как и любой alternate дистрибутив. Рассматривать подробности установки я не буду.

Далее стал вопрос о поднятии FTP сервера - первая попытка оказалась неудачной. Вторая оказалась более удачной. Мой выбор пал на Vsftpd. Основная причина такого выбора - простота настройки. Установка предельно проста. В терминале набираем команду:


sudo apt-get install vsftpd

и ждем завершения процесса установки.

Для того чтобы пользователи проходили авторизацию в системе и могли загружать файлы на сервер FTP, редактируем файл настроек:


sudo nano /etc/vsftpd.conf 

и изменяем нижеуказанные строки:

local_enable=YES
write_enable=YES


Перезагружаем vsftpd командой:


sudo /etc/init.d/vsftpd restart

Теперь когда в системе настроена авторизация, пользователи смогут входить через свою учетную запись на FTP-сервер, где в их домашнем каталоге они смогут скачивать, загружать, создавать каталоги и т.д.

Итак, файловый сервер работает. Осталось дело за малым - настроить торрен-клиент с удаленным доступом. У моего любимого Flush такого счастья, как клиент-демон и web-интерфейс не оказалось (ну или я плохо искал:-)), так что пришлось гуглить этот вопрос... И результат был найден. Даже несколько: uTorrent, transmission и Deluge. Первый был отброшен по причине незнания, трансмиссия уж очень замудренная какая то, а вот Deluge устраивал по всем параметрам. Итак, решено - ставим Deluge.


Чтобы получить последнюю версию добавляем PPA репозиторий:

sudo apt-get update
sudo apt-get install python-software-properties
sudo add-apt-repository ppa:deluge-team/ppa



Обновляем список пакетов:

sudo apt-get update

Устанавливаем клиента, консоль и демона и веб-интерфейс:

sudo apt-get install deluge-common deluge-console deluged deluge-webui

Запускаем демона:

deluged

Что бы включить удаленный доступ запускаем консоль:

deluge-console

И выполняем комманды:

config -s allow_remote True
config allow_remote

Выходим из консоли:

exit

Добавляем пользователя для удаленного доступа (эти данные никак не связаны с вашим linux пользователем) и указываем права доступа:

echo "username:password:level" >> ~/.config/deluge/auth
Подробнее по правам доступа тут.

И перезапускаем демона:

pkill deluged
deluged


Если хотим чтобы deluge запускался вмести с системой необходимо создать скрипты которые будут это делать.

Создаем конфиг:

sudo vim /etc/default/deluge-daemon

Вставляем туда этот код, обязательно в DELUGED_USER должен быть указан пользователь от имени которого будет работать демон:

# Configuration for /etc/init.d/deluge-daemon
# The init.d script will only run if this variable non-empty.
DELUGED_USER=""
# Should we run at startup?
RUN_AT_STARTUP="YES"
Создаем скрипт запуска:

sudo vim /etc/init.d/deluge-daemon

И пишем в него:

#!/bin/sh
### BEGIN INIT INFO
# Provides: deluge-daemon
# Required-Start: $local_fs $remote_fs
# Required-Stop: $local_fs $remote_fs
# Should-Start: $network
# Should-Stop: $network
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: Daemonized version of deluge and webui.
# Description: Starts the deluge daemon with the user specified in
# /etc/default/deluge-daemon.
### END INIT INFO
# Author: Adolfo R. Brandes
PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DESC="Deluge Daemon"
NAME1="deluged"
NAME2="deluge"
DAEMON1=/usr/bin/deluged
DAEMON1_ARGS="-d" # Consult `man deluged` for more options
DAEMON2=/usr/bin/deluge-web
DAEMON2_ARGS="" # Consult `man deluge-web` for more options
PIDFILE1=/var/run/$NAME1.pid
PIDFILE2=/var/run/$NAME2.pid
UMASK=022 # Change this to 0 if running deluged as its own user
PKGNAME=deluge-daemon
SCRIPTNAME=/etc/init.d/$PKGNAME
# Exit if the package is not installed
[ -x "$DAEMON1" -a -x "$DAEMON2" ] || exit 0
# Read configuration variable file if it is present
[ -r /etc/default/$PKGNAME ] && . /etc/default/$PKGNAME
# Load the VERBOSE setting and other rcS variables
[ -f /etc/default/rcS ] && . /etc/default/rcS
# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions
if [ -z "$RUN_AT_STARTUP" -o "$RUN_AT_STARTUP" != "YES" ]
then
 log_warning_msg "Not starting $PKGNAME, edit /etc/default/$PKGNAME to start it."
 exit 0
fi
if [ -z "$DELUGED_USER" ]
then
 log_warning_msg "Not starting $PKGNAME, DELUGED_USER not set in /etc/default/$PKGNAME."
 exit 0
fi
#
# Function that starts the daemon/service
#
do_start()
{
 # Return
 # 0 if daemon has been started
 # 1 if daemon was already running
 # 2 if daemon could not be started
 start-stop-daemon --start --background --quiet --pidfile $PIDFILE1 --exec $DAEMON1 \
 --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK --test > /dev/null
 RETVAL1="$?"
 start-stop-daemon --start --background --quiet --pidfile $PIDFILE2 --exec $DAEMON2 \
 --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK --test > /dev/null
 RETVAL2="$?"
 [ "$RETVAL1" = "0" -a "$RETVAL2" = "0" ] || return 1
 start-stop-daemon --start --background --quiet --pidfile $PIDFILE1 --make-pidfile --exec $DAEMON1 \
 --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK -- $DAEMON1_ARGS
 RETVAL1="$?"
 sleep 2
 start-stop-daemon --start --background --quiet --pidfile $PIDFILE2 --make-pidfile --exec $DAEMON2 \
 --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK -- $DAEMON2_ARGS
 RETVAL2="$?"
 [ "$RETVAL1" = "0" -a "$RETVAL2" = "0" ] || return 2
}
#
# Function that stops the daemon/service
#
do_stop()
{
 # Return
 # 0 if daemon has been stopped
 # 1 if daemon was already stopped
 # 2 if daemon could not be stopped
 # other if a failure occurred
 start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --user $DELUGED_USER --pidfile $PIDFILE2
 RETVAL2="$?"
 start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --user $DELUGED_USER --pidfile $PIDFILE1
 RETVAL1="$?"
 [ "$RETVAL1" = "2" -o "$RETVAL2" = "2" ] && return 2
 rm -f $PIDFILE1 $PIDFILE2
 [ "$RETVAL1" = "0" -a "$RETVAL2" = "0" ] && return 0 || return 1
}
case "$1" in
 start)
 [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME1"
 do_start
 case "$?" in
 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
 esac
 ;;
 stop)
 [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME1"
 do_stop
 case "$?" in
 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
 esac
 ;;
 restart|force-reload)
 log_daemon_msg "Restarting $DESC" "$NAME1"
 do_stop
 case "$?" in
 0|1)
 do_start
 case "$?" in
 0) log_end_msg 0 ;;
 1) log_end_msg 1 ;; # Old process is still running
 *) log_end_msg 1 ;; # Failed to start
 esac
 ;;
 *)
 # Failed to stop
 log_end_msg 1
 ;;
 esac
 ;;
 *)
 echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
 exit 3
 ;;
esac
:
Устанавливаем права на выполнение для root:

sudo chmod 755 /etc/init.d/deluge-daemon

Добавляем скрипт в автозагрузку и выгрузку:

sudo update-rc.d deluge-daemon defaults

Ну и проверяем сделанную работу:

sudo reboot

А как пользоваться то этим всем? Мне удобней всего через web-"морду". В браузере набираем адрес своего сервера и указываем порт. Выглядит это примерно вот так: http://ip-adress-your-server:2118 и попадаем в веб-интерфейс Deluge. Будет затребован пароль. По-умолчанию пароль: deluge. Сменить можно в любое время. Ну а дальше, я думаю, разобраться не сложно...

web-интерфейс Deluge

Удачи!

---------------------------------------
Использованные материалы:
Установка и настройка FTP-сервера в Ubuntu
Установка Deluge BitTorrent в Ubuntu Server
Поисковая система Google

5 комментариев :

  1. з.ы. А еще я от него телефон заряжаю... :-)

    ОтветитьУдалить
  2. Прикольная шняжка, я так понял оно у тебя теперь торренты качает делугой (у меня такое)? И кстати - FTP не очень прикольно на таких вещах юзать (мне не очень нравится, да и скорость обычно не очень, по крайней мере у меня на роутере), лучше юзать самбу, но это целая история шаманств и танцов с бубном.

    ОтветитьУдалить
  3. Отчего же не прикольно? Скорость 11,5 МБ в сек (на большее сетевая не способна у НР) а в остальном все пристойно и очень даже ничего...

    ОтветитьУдалить
  4. У меня после роутера плохие впечатления о FTP

    ОтветитьУдалить
  5. Ну дык,это ж не роутер... пошустрей будет железка...

    ОтветитьУдалить

счетчик посещений